/*

            ^OtBNX\

        Copyright 2009-2011 , Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <util/delay.h>
#include "lcdInterface.h"

#define LCD_SELECT          PORTD &= ~_BV(PD7)
#define LCD_DESELECT        PORTD |= _BV(PD7)
#define NOP                 asm("nop")
#define NOP_2               NOP;NOP

//==========================================
//  ̒`̂ǂ炩PLɂĂ
//==========================================
#define INTERFACE_PARALLEL_80       // pڑ
//#define INTERFACE_SPI_3             // 3SPIڑ
//==========================================
/*
֐writeByte֐u邱ƂŁA
C^[tF[XύX邱Ƃł܂B
*/

#ifdef INTERFACE_PARALLEL_80
/*
80npC^[tF[Xł́A
[hɂRDbMACgɂWRbMo͂܂B
*/
#define LCD_A0_CMND         PORTC &= ~_BV(PC0)
#define LCD_A0_DATA         PORTC |= _BV(PC0)
#define LCD_WR_LOW          PORTC &= ~_BV(PC1)
#define LCD_WR_HIGH         PORTC |= _BV(PC1)

void initInterface()
{
    PORTC |= 0x07;
    PORTD |= 0x80;
    DDRB |= 0xFF;
    DDRC |= 0x07;
    DDRD |= 0x80;
}

void writeByte(char dc, unsigned char b)
{
    while(checkBusy());
    PORTB = b;          // |[gBɃf[^o
    if(dc) {            // dcf[^̎
        LCD_A0_DATA;        // A0HIGHɂ
    } else {            // dcR}h̎
        LCD_A0_CMND;        // A0LOWɂ
    }
    LCD_SELECT;         // CSbLOWɂ
    LCD_WR_LOW;         // WRbLOWɂ
    NOP_2;              // KvȃpXmۂ
    LCD_WR_HIGH;        // WRbHIGHɂ
    LCD_DESELECT;       // CSbHIGHɂ
}

#endif


#ifdef INTERFACE_SPI_3
/*
RSPIł̓f[^ƃR}h̋ʂ\Prbg̃tOA
of[^̍ŏʃrbgɕtāAXrbgf[^Ƃđo܂B
*/

#define LCD_SI_LOW          PORTB &= ~_BV(PB7)
#define LCD_SI_HIGH         PORTB |= _BV(PB7)
#define LCD_SCL_LOW         PORTB &= ~_BV(PB6)
#define LCD_SCL_HIGH        PORTB |= _BV(PB6)

void initInterface()
{
    LCD_DESELECT;
    LCD_SCL_LOW;
    LCD_SI_LOW;
    PORTC |= 0x07;
    DDRB |= 0xC0;
    DDRC |= 0x07;
    DDRD |= 0x80;
}

void writeByte(char dc, unsigned char b)
{
    int sendWork = b;
    while(checkBusy());
    if(dc) {        
        sendWork |= 0x100 ;   // A0=1 : Data
    }
    LCD_SELECT;         // CSbLOWɂ
    for(char bitCount = 0; bitCount < 9; bitCount++)    // 9rbgJԂ
    {
        if(sendWork & 0x100) {
            LCD_SI_HIGH;    // rbglP̂ƂASIHIGHɂ
        } else {
            LCD_SI_LOW;     // rbglÔƂASILOWɂ
        }
        LCD_SCL_HIGH;       //  SCLHIGHIɂ
        sendWork = sendWork << 1;   // pXmۂԂɃf[^Vtg
        LCD_SCL_LOW;        // SCLLOWɂ
    }
    LCD_DESELECT;       // CSbHIGHɂ
}

#endif



void writeData(char d)
{
    writeByte(1, d);
}

void writeCmnd(char c)
{
    writeByte(0, c);
}

char checkBusy()
{
    return ((PINC & _BV(PC5)) != 0);
}

void initLcd(int p)
{
    //writeCmnd(0b01010000);      // \]
    writeCmnd(0b01010001);      // \]
    writeCmnd(0b00110100);      // \JnC(H)
    writeCmnd(0b00100001);      // \JnC(L)
    writeCmnd(0b01100000);      // SEG shift
    writeCmnd(0b01110001);      // COM shift
    initPulsWidth(p);
}

void initPulsWidth(int p)
{
    writeCmnd(0b10110001);  // TuECXgNVE[hJn
    writeCmnd(0b11110000 | ((p >> 8) & 0x03));  // pX
    writeCmnd(0b10100000 | ((p >> 4) & 0x07));  // SԃpXiH)
    writeCmnd(0b10010000 | (p & 0x0F));         // SԃpXiL)
    writeCmnd(0b01100000);                      // v[i[TCN
    writeCmnd(0b01110000);                      // tH[JTCN
    writeCmnd(0b10000000);                      // pXTCN
    writeCmnd(0b10110000);  // TuECXgNVE[hI
}



